if not MainMenuBarBackpackButton:IsVisible() then return end

local _, addon = ...
local module = addon:NewModule("Storage:Gold")

local GoldDB, Gold, options = {}
addon.GoldDB = GoldDB

local defaults = {
    profile = {
        hideConnectedRealmsNames = true,
        minGoldAmount = 0
    }
}

function module:OnInitialize()
    options = addon.DB:RegisterNamespace("Gold", defaults)
    if not addon.DB.global.Gold then
        addon.DB.global.Gold = {}
    end
    Gold = addon.DB.global.Gold
end

function GoldDB:UpdateGold(player, money)
    Gold[player] = money
end

function GoldDB:GetGoldInfo()
    return pairs(Gold)
end

function GoldDB:ResetGold()
    for player in self:GetGoldInfo() do
        Gold[player] = nil
    end
    Gold[addon.Character:GetFullName()] = GetMoney()
end

function GoldDB:SetMinGoldAmount(value)
    options.profile.minGoldAmount = tonumber(value)
end

function GoldDB:GetMinGoldAmount()
    return options.profile.minGoldAmount or 0
end

function GoldDB:ToggleConnectedRealmsNames()
    options.profile.hideConnectedRealmsNames = not options.profile.hideConnectedRealmsNames
end

function GoldDB:IsConnectedRealmsNamesHidden()
    return options.profile.hideConnectedRealmsNames
end
